<id>
Poll Mod
</id>

<version>
2.0
</version>

<mod info>
This mod adds poll capability to your YaBB 1 Gold SP1 Board. The polls themselves are similar to that of vB and YaBB SE.

To install, place Poll.pl in your /Sources directory, place the images into your YaBBImages directory and install the mod file as usual with BoardMod.

Have fun!

Changes in version 1.2: All known bugs should be fixed! ;)
Changes in Version 2: 

- Voter Details panel added
- Speed increase
- Options (which are new features) added within admin center:
	~ Number of Poll Options
	~ Allow users to add polls to their own threads?
	~ Allow users to edit their own polls?
	~ Allow users to delete their own polls?
	~ Enable Guest Voting?
- Entire Mod Rewritten for more mod compatibility
- Lock/Unlock feature added
- Looks better
- Partial Smiley Support added (Not all work due to the nature of being able to vote properly)
</mod info>

<author>
Shoeb Omar (Omario), Sam Holman (Samm)
</author>

<homepage>
http://www.clickopedia.com
</homepage>

<edit file>
Sources/Display.pl
</edit file>

<search for>
<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
    <table cellpadding="3" cellspacing="1" border="0" width="100%">
      <tr>
        <td valign="middle" align="left" width="20%" bgcolor="$color{'titlebg'}" class="titlebg">
</search for>

<add before>
~;

	# Look for a poll file for this thread.
	
	if (-e "$datadir/$viewnum.poll") { $pollthread = 1; }
	
if ($pollthread) {
	fopen (FILE, "$datadir/$viewnum.poll");
		@polldata = <FILE>;
	fclose (FILE);

	$pollquestion = $polldata[0];
	$pollquestion =~ s~\n~~g;
	($question, $lockstatus) = split(/\|/, $pollquestion);
	$num = 1;
	$line = 0;
	my @options;
	my @votes;
	foreach $pointer (@polldata) {
		($vote, $option) = split(/\|/, $polldata[$num]);
		$options[$line] = $option;
		$votes[$line] = $vote;
		$line++;
		$num++;
	}
	
	$search = -1;
	my $found;
	$usersemail = $settings[2];
	$userstatus = $settings[7];
	$found = &CheckVoted($viewnum); 
	
	if ($found) { $userhasvoted = 1; }
	$viewresults = $INFO{'viewresults'};
	if ($lockstatus eq "Locked") { $pollislocked = 1; }
	
	if ($username ne "Guest" && ($username eq $susername) || ($userstatus eq "Administrator" or $userstatus eq "Global Moderator" or exists $moderators{$username})) { $modifypoll = qq~<a href="$cgi;action=modify;message=0;thread=$viewnum" class="altlink"><img src="$imagesdir/modify.gif" border="0">$polltxt{'39'}</a>&nbsp;~; }
	if (($userstatus eq "Administrator" || $userstatus eq "Global Moderator" || exists $moderators{$username}) && ($pollislocked ne 1)) { $lockpoll = qq~<a href="$cgi;action=lockpoll;num=$viewnum" class="altlink">$img{'polliconclosed'} $polltxt{'20'}</a>&nbsp;~; }
	if (($userstatus eq "Administrator" || $userstatus eq "Global Moderator" || exists $moderators{$username}) && ($pollislocked eq 1)) { $lockpoll = qq~<a href="$cgi;action=unlockpoll;num=$viewnum" class="altlink">$img{'polliconclosed'} $polltxt{'21'}</a>&nbsp;~; }
	if ($userstatus eq "Administrator"){ $displayvoters = qq~<a href="$cgi;action=showvoters;num=$viewnum" class="altlink"><img src="$imagesdir/register.gif" border="0"> $polltxt{'33'}</a>~;}
	$vresults = qq~<a href="$cgi;action=display;num=$viewnum;viewresults=yes" class="altlink">$polltxt{'19'}</a>~;
	if ($pollislocked eq 1) { $endedtext = $polltxt{'22'}; }


	$poll_icon = qq~$img{'pollicon'}~;
	if ($pollislocked == 1) { $poll_icon = qq~$img{'polliconclosed'}~; }

	$yymain.= qq~<table border="0" width="100%" cellspacing="1" cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td valign="middle" align="left" bgcolor="$color{'titlebg'}" class="titlebg" width="20%"><font size=2 class="text1" color="$color{'titletext'}">&nbsp;$poll_icon <b>$polltxt{'15'}</b></font></td>
    <td valign="middle" align="center" bgcolor="$color{'titlebg'}" class="titlebg" width="45%"><font size=2 class="text1" color="$color{'titletext'}"><b>$endedtext</b></font></td>
    <td valign="middle" align="right" bgcolor="$color{'titlebg'}" class="titlebg" width="35%"><font size=1 color="$color{'titletext'}">$lockpoll &nbsp; $displayvoters &nbsp; $modifypoll</font></td>
 </tr><tr>
    <td colspan="3" valign="top" align="center" bgcolor="$color{'windowbg2'}" class="windowbg2">
~;
	# Censor the question.
	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$question =~ s~\Q$tmpa\E~$tmpb~gi;
	}

	if (($userhasvoted) || $viewresults eq 'yes' || $pollislocked eq 1 ) {
	
		
		$yymain.= qq~
      <table border="0" width="100%" cellspacing="0" cellpadding="5" bgcolor="$color{'windowbg2'}" class="windowbg2">
        <tr valign="top">
          <td><font size="2"><b>$polltxt{'16'}:</b>  $question</font><br><br></td>
        </tr>
        <tr> 
          <td align="center">
            <table border="0" cellspacing="0" cellpadding="0">~;
		$nums = 0;
    
		my $Key; 
		my $Total; 
		$maxvote = 0;
		foreach $Key (@votes) { 
			$Total += $Key; 
			if ($Key >= $maxvote) { $maxvote = $Key;}
		} 

		$totalvotes = $Total;
		pop (@options);
		foreach (@options) {

			# Censor the options.
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$options[$nums] =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			$message = $options[$nums]; # put the message back into the proper variable to do ubbc on it
			if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &MakeSmileys;
			$options[$nums] = $message;
			$options[$nums] =~ s~\n~~g;
			$options[$nums] =~ s~<br>~~g;
			$yymain .= qq~
              <tr> 
                <td><b><font size="2">$options[$nums]</font></b></td>
                <td width="250">~;

# Now lets calculate how many devisions by the total number of votes are needed to make the bar graphs stay nicely sized in the browser window:

			$pollpercent = 0;
			$pollbar = 0;
			if ($totalvotes ne 0 && $maxvote ne 0) {
				$pollpercent = int(1000 * $votes[$nums] / $totalvotes);
				$pollpercent = $pollpercent / 10; 
				$pollbar = int( 150 * $votes[$nums] / $maxvote);
			}
    
			$yymain .= qq~&nbsp;&nbsp;<img src="$imagesdir/poll_left.gif" align="middle"><img src="$imagesdir/poll_middle.gif" height="12" width="$pollbar" align="middle"><img src="$imagesdir/poll_right.gif" align="middle"> <font size="2">$votes[$nums] ($pollpercent%)</font></td>
              </tr>~;
			$nums++;
		}

		$yymain .= qq~
            </table>
            <br><b><font size="2">$polltxt{'17'}: $totalvotes</font></b>
          </td>
        </tr>
      </table>
~;
	}
	else {
		$board = $INFO{'board'};
		$yymain.= qq~
      <form name="poll" method="post" action="$cgi;action=vote;board=$board;num=$viewnum">
        <table border="0" width="100%" cellspacing="0" cellpadding="5">
          <tr valign="top"> 
            <td><font size="2"><b>$polltxt{'16'}:  </b>$question</font></td>
          </tr>
          <tr> 
            <td align="center">
              <table width="90%" border="0" cellspacing="0" cellpadding="0">~;
		$nums = 0;
		pop (@options);
		foreach (@options) {
			# Censor the options.
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$options[$nums] =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			$options[$nums] =~ s~\n~~g;
			$options[$nums] =~ s~<br>~~g;
			$message = $options[$nums]; # put the message back into the proper variable to do ubbc on it
			if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &MakeSmileys;
			$options[$nums] = $message;
			$yymain .= qq~
                <tr valign="top"> 
                  <td width="5%"><INPUT type="radio" name="option" value="$nums"></td>
                  <td width="95%" valign="middle"><font size="2">$options[$nums]</font></td>
                </tr>~;
			$nums++;
  		}
		$yymain .= qq~
              </table>
            </td>
          </tr>
          <tr>
            <td align="center"><INPUT type="submit" value="$polltxt{'18'}"><br><font size="2">$vresults</font></td>
          </tr>
        </table>
      </form>
~;
	}
$yymain .= qq~
    </td>
  </tr>
</table>~;	
}
$yymain .= qq~
</add before>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>&nbsp;
	    </font></td>

</search for>

<replace>
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>
	    <a href="$cgi;action=post;title=$polltxt{'2'}">$img{'createpoll'}</a>&nbsp;
	    </font></td>

</replace>

<search for>
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>&nbsp;
	    </font></td>
</search for>

<replace>
# Modification 2
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>
	    <a href="$cgi;action=post;title=$polltxt{'2'}">$img{'createpoll'}</a>&nbsp;
	    </font></td>
</replace>

<search for>
		foreach $curnum (@stickys) {
			if ($mnum == $curnum) {
				if($threadclass eq 'locked') { $threadclass = 'stickylock'; }
				else { $threadclass = 'sticky'; }
			}
		}
</search for>

<add after>
		$pollthread = 0;
		fopen (FILE, "$datadir/$mnum.poll");
		@data = <FILE>; 
		fclose (FILE);
		chomp $data[0];
		($question, $lockstatus) = split(/\|/, $data[0]);
		
		if (-e "$datadir/$mnum.poll") {
			$micon = "poll_icon";		
		}
		if ($lockstatus eq "Locked") {
			$micon = "poll_icon_closed";
		}
		else { $pollimg = qq~$img{'pollicon'}~; }
</add after>

<edit file>
Sources/RemoveThread.pl
</edit file>

<search for>
	unlink("$datadir/$thread.txt");
	unlink("$datadir/$thread.mail");
	unlink("$datadir/$thread.data");
</search for>

<add after>
	unlink("$datadir/$thread.poll");
	unlink("$datadir/$thread.polled");
	unlink("$datadir/$thread.polll");
</add after>

<edit file>
Sources/RemoveOldThreads.pl
</edit file>

<search for>
					unlink("$datadir/$num.txt");
					unlink("$datadir/$num.mail");
					unlink("$datadir/$num.data");
</search for>

<add after>
					unlink("$datadir/$num.poll");
					unlink("$datadir/$num.polled");
					unlink("$datadir/$num.polll");
</add after>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
			unlink("$datadir/$tnum.txt");
			unlink("$datadir/$tnum.mail");
			unlink("$datadir/$tnum.data");
</search for>

<add after>
			unlink("$datadir/$tnum.poll");
			unlink("$datadir/$tnum.polled");
			unlink("$datadir/$tnum.polll");
</add after>

<search for>
	}
	# Save the current board.
</search for>

<add before>
		if ($FORM{'poll'} == 1) {
			if (($userdelpoll == 1) && ($FORM{"killpoll"} eq "kp")){
				unlink("$datadir/$tnum.poll");
				unlink("$datadir/$tnum.polled");
				unlink("$datadir/$tnum.polll");
			}
			else{
				$numcount = 0;
				
				if (length($FORM{"question"}) > 60) { &fatal_error("$polltxt{'40'}"); }
				if ( $FORM{"question"} =~ m/\|/g) { &fatal_error("$polltxt{'41'}"); }
				for ($i = 1; $i <= $numpolloptions; $i++){
					if (length($FORM{"option$i"}) > 50) { &fatal_error("$polltxt{'7'} $i $polltxt{'34'}"); }
					if ( $FORM{"option$i"} =~ m/\|/g) { &fatal_error("$polltxt{'35'} $i $polltxt{'35'}"); }
					$FORM{"option$i"} =~ s/"/&quot;/g;
					if ($FORM{"option$i"}) {
						@options[$numcount] = $FORM{"option$i"};
						$numcount++;
					}
				}
			unless ($FORM{"question"}) { &fatal_error("$polltxt{'37'}"); }
			unless ($FORM{"option1"}) { &fatal_error("$polltxt{'38'}"); }
			unless ($FORM{"option2"}) { &fatal_error("$polltxt{'38'}"); }
			fopen (FILE, "$datadir/$threadid.poll");
			@info = <FILE>;
			fclose (FILE);
			unlink ("$datadir/$threadid.poll");
			$optcount = 1;
			foreach $option (@options) {
				if (!$info[$optcount]){
					$info[$optcount] = 0;
				}
				($number, $crud) = split(/\|/, $info[$optcount]);
				$printpoll[$optcount] = qq~$number|$option\n~;
				$optcount++;
			}
			fopen (POLL, ">$datadir/$threadid.poll");
			print POLL "$FORM{'question'}|$FORM{'lockornot'}\n";
			print POLL @printpoll;
			fclose (POLL);
			}
		}
</add before>

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
			unlink("$datadir/$id\.txt");
			unlink("$datadir/$id\.mail");
			unlink("$datadir/$id\.data");
</search for>

<add after>
			unlink("$datadir/$id\.poll");
			unlink("$datadir/$id\.polled");
			unlink("$datadir/$id\.polll");
</add after>

<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
					unlink("$datadir/$id.txt");
					unlink("$datadir/$id.mail");
					unlink("$datadir/$id.data");
</search for>

<add after>
					unlink("$datadir/$id.poll");
					unlink("$datadir/$id.polled");
					unlink("$datadir/$id.polll");
</add after>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	$message =~ s~<yabbbr>~\n~g;
	&ToHTML($message);
	$message =~ s~\t~ &nbsp; &nbsp; &nbsp;~g;
	$message =~ s~\n~<br>~g;
</search for>

<add after>
	$message =~ s~\[poll\](.+?)\[/poll\]~~isg;
</add after>

<search for>
# One should never criticize his own work except in a fresh and hopeful mood. 
# The self-criticism of a tired mind is suicide. 
# - Charles Horton Cooley
</search for>

<add after>
sub CheckVoted {
	my ($viewnum, $writetofile) = @_;
	fopen(FILE, "$datadir/$viewnum.polled");
	@polled = <FILE>;
	fclose(FILE);
	$i = 0;
	foreach $LineNum (@polled){
		($votersemail, $votersname, $votersvote) = split(/\|/, $LineNum);
		if ($username eq "Guest") {
			if ($votersemail =~ /\b$user_ip\b/) { $founduser = 1; last; }
		} else {
			if ($username eq $votersname) { $founduser = 1; last; }
			elsif ($votersemail =~ /\b$user_ip\b/ && $votersname eq "Guest") { 
				# Remove guest entry from Polled Log
				if ($writetofile eq "yes"){
					$polled[$i] = "";
					fopen(FILE, ">$datadir/$viewnum.polled");
					print FILE @polled;
					fclose(FILE);
                   
					fopen (FILE, "$datadir/$viewnum.poll");
					@options = <FILE>;
					fclose (FILE);
					$votersvote++;
					($optvotes, $optname) = split(/\|/, $options[$votersvote]);
					$optvotes --;
					$options[$votersvote] = "$optvotes|$optname";
					fopen (FILE, ">$datadir/$viewnum.poll");
					print FILE @options;
					fclose (FILE);
				}
			}
		}
		$i++;
	}
	return $founduser;
} 
</add after>

<edit file>
English.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>
$polltxt{'1'} = "Create Poll";
$polltxt{'2'} = "Create+Poll"; #do not translate this line
$polltxt{'3'} = "Create Poll";
$polltxt{'4'} = "Poll Question";
$polltxt{'5'} = "shortcuts (IE and NS6 only): hit alt+s to send or alt+r to reset";
$polltxt{'6'} = "Question";
$polltxt{'7'} = "Option";
$polltxt{'8'} = "Guests are not allowed to vote. Please register.";
$polltxt{'9'} = "An error occured with this poll and the vote could not be counted. Sorry for the inconvinience.";
$polltxt{'10'} = "You have already voted in this poll";
$polltxt{'11'} = "This poll is locked so your vote could not be counted";
$polltxt{'12'} = "This poll is already locked";
$polltxt{'13'} = "You are not allowed to perform that action";
$polltxt{'14'} = "This poll is already unlocked";
$polltxt{'15'} = "Poll";
$polltxt{'16'} = "Question";
$polltxt{'17'} = "Total votes";
$polltxt{'18'} = "Submit Vote";
$polltxt{'19'} = "View Results";
$polltxt{'20'} = "Lock voting";
$polltxt{'21'} = "Unlock voting";
$polltxt{'22'} = "This poll has ended. Here are the results:";
$polltxt{'23'} = "Details for Poll:";
$polltxt{'24'} = "Voters";
$polltxt{'25'} = "Nobody voted for this option.";
$polltxt{'26'} = "Click here to add a poll to this thread";
$polltxt{'27'} = "Delete this poll from your post";
$polltxt{'28'} = "Number of Poll Options:";
$polltxt{'29'} = "Allow users to add polls to their own existing threads:";
$polltxt{'30'} = "Allow users to edit their own polls:";
$polltxt{'31'} = "Allow users to delete their own polls:";
$polltxt{'32'} = "Enable Guest Voting:";
$polltxt{'33'} = "View Voters";
$polltxt{'34'} = "was longer than the maximum 50 characters. Please try again.";
$polltxt{'35'} = "There was an illegal character in option";
$polltxt{'36'} = "Please try again.";
$polltxt{'37'} = "Please supply a poll question.";
$polltxt{'38'} = "Please provide at least 2 poll options, starting from option 1.";
$polltxt{'39'} = "Modify Poll";
$polltxt{'40'} = "Your poll question was longer than the maximum 60 characters. Please try again.";
$polltxt{'41'} = "There was an illegal character in your poll question. Please try again.";
$polltxt{'42'} = "Poll Details";

</add before>

<search for>
	$img{'website_sm'} = qq~<font size="1" class="imgwindowbg">$txt{'515'}</font>~;
</search for>

<add after>
	$img{'createpoll'} = qq~<font size="1" class="imgcatbg">$polltxt{'1'}</font>~;
</add after>

<search for>
	$img{'website_sm'} = qq~<img src="$imagesdir/www.gif" alt="$txt{'515'}" border="0">~;
</search for>

<add after>
	$img{'createpoll'} = qq~<img src="$imagesdir/createpoll.gif" alt="$polltxt{'1'}" border="0"> <font size="1" class="imgcatbg">$polltxt{'1'}</font>~;
	$img{'pollicon'} = qq~<img src="$imagesdir/poll_icon.gif" alt="$polltxt{'24'}" border="0">~;
	$img{'polliconclosed'} = qq~<img src="$imagesdir/poll_icon_closed.gif" alt="$polltxt{'23'}" border="0">~;

</add after>

<edit file>
YaBB.pl
</edit file>

<search for>
	elsif ($action eq 'clean_log') { require "$sourcedir/Admin.pl"; &clean_log; }
</search for>

<add after>
	elsif ($action eq 'createpoll') { require "$sourcedir/Poll.pl"; &CreatePoll; }
	elsif ($action eq 'createpoll2') { require "$sourcedir/Poll.pl"; &CreatePoll2; }
</add after>

<search for>
	elsif ($action eq 'usersrecentposts') { require "$sourcedir/Profile.pl"; &usersrecentposts; }
</search for>

<add after>
	elsif ($action eq 'vote') { require "$sourcedir/Poll.pl"; &DoVote; }
	elsif ($action eq 'unlockpoll') { require "$sourcedir/Poll.pl"; &UnlockPoll; }
</add after>

<search for>
	elsif ($action eq 'lock') { require "$sourcedir/LockThread.pl"; &LockThread; }
</search for>

<add after>
	elsif ($action eq 'lockpoll') { require "$sourcedir/Poll.pl"; &LockPoll; }
</add after>

<search for>
	elsif ($action eq 'sticky') { require "$sourcedir/Subs.pl"; &Sticky; }
</search for>

<add after>
	elsif ($action eq 'showvoters') { require "$sourcedir/Poll.pl"; &votedetails; }

</add after>

<edit file>
Sources/Post.pl
</edit file>

<search for>
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg2'}" class="windowbg2">
</search for>

<add after>
<!-- Poll Mod 2-->
$polloptions
</add after>

<search for>
	if ($FORM{'waction'} =~ /preview/) {$txt{'507'}=$txt{'771'};}
</search for>

<add after>
	if (-e "$datadir/$INFO{'thread'}.poll"){
		fopen (FILE, "$datadir/$INFO{'thread'}.poll");
		@polloptions = <FILE>;
		fclose (FILE);
		chomp $polloptions[0];
		($question, $unorlock) = split(/\|/, $polloptions[0]);
	}
	if (($useraddpoll == 1) && ((!(-e "$datadir/$INFO{'thread'}.poll") && $INFO{'title'} !~ /Poll/) && ($INFO{"action"} eq "modify" && $INFO{"message"} == 0))){
		$addthis = qq~
		<tr>
		<td valign=top width="23%"><font size=2><b>$polltxt{'15'}:</b></font></td>
		<td><font size=2><a href="$cgi;action=modify;message=0;thread=$INFO{'thread'};title=Poll">$polltxt{'26'}</a></font></td>
		</tr>~;
	}
if (($INFO{'title'} =~ /Poll/ && $threadid eq '') || ($INFO{"action"} eq "modify" && $INFO{'message'} == 0 && (($INFO{'title'} =~ /Poll/ && $useraddpoll == 1) || (-e("$datadir/$INFO{'thread'}.poll") && $usereditpoll == 1)))) { $ispollthread = 1;
chomp $polloptions[0];
$polloptions .= qq~
<tr>
<td align=left><font size=2><b>$polltxt{'6'}:</b></font></td>
<td align=left><INPUT size="40" name="question" value="$question" maxlength="60"></td></tr>
<tr>
<td>&nbsp;</td>
<td>
<table cellpadding=0 cellspacing=0 border=0>
~;
$pollcount = 1;
while ($pollcount <= $numpolloptions){
	($crap, $needed) = split(/\|/, $polloptions[$pollcount]);
	chomp $needed;
	if ($pollcount == 1){
	$polloptions .= qq~<tr><td><font size=2>$polltxt{'7'} 1:&nbsp; </font></td> <td><INPUT size=25 maxlength="50" name=option1 value="$needed"></td></tr>~;
	}
	else{ $polloptions .= qq~
                 <tr><td><font size=2>$polltxt{'7'} $pollcount:&nbsp; </font></td> <td><INPUT size=25 maxlength="50" name=option$pollcount value="$needed"></td></tr>~;
                 }
$pollcount ++;
}
$polloptions .= qq~</table></td></tr>~;
if (($userdelpoll == 1) && (($INFO{"action"} eq "modify" && $INFO{"message"} == 0) && (-e "$datadir/$INFO{'thread'}.poll"))){ $polloptions .= qq~<tr><td></td><td><input type="checkbox" name="killpoll" value="kp"> $polltxt{'27'}</td></tr>~;}
}
</add after>

<search for>
	if($newthreadid) {
		# This is a new thread. Save it.
</search for>

<add before>
if ($FORM{'poll'} == 1) {	
	$numcount = 0;
	
	if (length($FORM{"question"}) > 60) { &fatal_error("$polltxt{'40'}"); }
	if ( $FORM{"question"} =~ m/\|/g) { &fatal_error("$polltxt{'41'}"); }
	
	for ($i = 1; $i <= $numpolloptions; $i++){
		if (length($FORM{"option$i"}) > 50) { &fatal_error("$polltxt{'7'} $i $polltxt{'34'}"); }
		if ( $FORM{"option$i"} =~ m/\|/g) { &fatal_error("$polltxt{'35'} $i"); }
		$FORM{"option$i"} =~ s/"/&quot;/g;
		if ($FORM{"option$i"}) {
			@options[$numcount] = $FORM{"option$i"};
			$numcount++;
		}
	}
	unless ($FORM{"question"}) { &fatal_error("$polltxt{'37'}"); }
	unless ($FORM{"option1"}) { &fatal_error("$polltxt{'38'}"); }
	unless ($FORM{"option2"}) { &fatal_error("$polltxt{'38'}"); }
	}
</add before>

<search for>
$notification
$lastmod
</search for>

<add after>
$addthis
</add after>

<search for>
	} else {
		# This is an old thread. Save it.
</search for>

<add before>
		if ($FORM{'poll'} == 1) {
		fopen (FILE, ">$datadir/$newthreadid.poll");
		print FILE "$FORM{'question'}|$FORM{'lockornot'}\n";
		foreach $option (@options) {
			print FILE "0|$option\n";
		}
		fclose (FILE);
		}
</add before>

<search for>
        <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
</search for>

<add after>
$polloptions
</add after>

<search for>
    <input type=hidden name="postid" value="$postid">
</search for>

<add after>
    <input type=hidden name="lockornot" value="$unorlock">
    <input type=hidden name="poll" value="$ispollthread">
</add after>

<search for>
		<input type="submit" name="$preview" value="$txt{'507'}" onClick="WhichClicked('$preview');" accesskey="p">
~;
</search for>

<replace>
~;
unless (($INFO{'title'} =~ /Poll/) || (($INFO{"action"} eq "modify" && $INFO{"message"} == 0) && (-e "$datadir/$INFO{'thread'}.poll"))){ $yymain .= qq~<input type="submit" name="$preview" value="$txt{'507'}" onClick="WhichClicked('$preview');" accesskey="p">~; }
</replace>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	if ($showyabbcbutt) { $syabbcchecked = "checked" }
</search for>

<add after>
	if ($useraddpoll) { $uapchecked = "checked" }
	if ($usereditpoll) { $uepchecked = "checked" }
	if ($userdelpoll) { $udpchecked = "checked" }
	if ($guestvoting) { $gvchecked = "checked" }
</add after>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'746'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowpics" $allowpicschecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'381'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_notification" $notifchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'723'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allow_hide_email" $ahmchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'689'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxsiglen" size="5" value="$MaxSigLen"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'408'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="timeout" size="5" value="$timeout"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
</search for>

<add before>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'28'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="numpolloptions" size="5" value="$numpolloptions"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'29'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="useraddpoll"$uapchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'30'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="usereditpoll"$uepchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'31'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="userdelpoll" $udpchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'32'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="guestvoting" $gvchecked></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
</add before>

<search for>
	my($menuchecked, $ubbcchecked, $aluchecked, $cpchecked, $pbchecked, $insertchecked, $newschecked, $gpchecked, $notifchecked);
</search for>

<add after>
	my ($uapchecked, $uepchecked, $udpchecked, $gvchecked);
</add after>

<search for>
	my @onoff = qw/
		allowpics showyabbcbutt showbdescrip maintenance guestaccess insert_original enable_ubbc enable_news enable_guestposting enable_notification showlatestmember showrecentbar showmarkread showmodify showuserpic showusertext showgenderimage shownewsfader MenuType curposlinks profilebutton autolinkurls emailpassword RegAgree emailwelcome allow_hide_email usetempfile faketruncation emailnewpass/;
</search for>

<add after>
	push(@onoff, "useraddpoll", "usereditpoll", "userdelpoll", "guestvoting");
</add after>

<search for>
	$maxmesslen = $FORM{'maxmesslen'} || 5000;
</search for>

<add after>
	$numpolloptions = $FORM{'numpolloptions'} || 8;
</add after>

<search for>
\$MaxMessLen = $maxmesslen;  				# Maximum Allowed Characters in a Posts
</search for>

<add after>
\$numpolloptions = $numpolloptions;  				# Number of poll options
\$useraddpoll = $useraddpoll;  				# Allow users to add polls to their own existing threads? (1 = yes)
\$usereditpoll = $usereditpoll;  				# Allow users to edit their own polls? (1 = yes)
\$userdelpoll = $userdelpoll;  				# Allow users to delete their own polls? (1 = yes)
\$guestvoting = $guestvoting;  				# Allow guests to vote? (1 = yes)
</add after>

<edit file>
Sources/MoveThread.pl
</edit file>

<search for>
				if ($1 eq 'mail' && -e "$datadir/$thread.mail") { unlink("$datadir/$thread.mail"); }
</search for>

<add after>
if ($1 eq 'poll' && -e "$datadir/$thread.poll") { unlink("$datadir/$thread.poll"); } 
if ($1 eq 'polled' && -e "$datadir/$thread.polled") { unlink("$datadir/$thread.polled"); } 
if ($1 eq 'polll' && -e "$datadir/$thread.polll") { unlink("$datadir/$thread.polll"); } 
</add after>

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
	$message =~ s/(\W)\:\-\//$1\<img border=0 src=$imagesdir\/undecided.gif\>/g;
</search for>

<add after>
	$message =~ s/:\-\//<img border=0 src=$imagesdir\/undecided.gif\>/g;
</add after>

<search for>
	$message =~ s/\Q&gt;:(\E/\<img border=0 src=$imagesdir\/angry.gif\>/g;
</search for>

<add after>
	$message =~ s/\Q>:(\E/\<img border=0 src=$imagesdir\/angry.gif\>/g;
</add after>